using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Web.Administration;

namespace IT_notebook.IIS
{
	/*
	Created by: Kristofer Gafvert
	Published at: http://www.it-notebook.org/iis/article/cs_enum_modules_iis.htm
	Purpose: List enabled modules for a website. IIS 7.0, IIS 7.5.
	
	Free to use, but not publish in its entire to other website.
	
	*/
	class ListModules
	{
		static void Main(string[] args)
		{
			string website = args[0]; //Get the website name from an argument
			
			ServerManager serverManager = new ServerManager();
			
			SiteCollection sitesOnServer = serverManager.Sites; //Get a list of websites on the server
			
			bool siteFound = false;
			//iterate all websites on the server, and see if we can find the one we are looking for
			foreach(ConfigurationElement element in sitesOnServer.GetCollection())
			{
				if(website == element.GetAttributeValue("name").ToString())
				{
					//We have a matching website
					siteFound = true;
					break;
				}
				//Console.WriteLine(element.GetAttributeValue("name"));
			}
			
			if(siteFound)
			{
				//Get the configuration for the website
				Configuration config = serverManager.GetWebConfiguration(website);
				//Get the configuration section for modules
				ConfigurationSection section = config.GetSection("system.webServer/modules");
				foreach(ConfigurationElement element in section.GetCollection())
				{
					Console.WriteLine(element.GetAttribute("name").Value);
				}
			}
			else
			{
				string response = 	"Sorry, but there is no matching website. " + 
									"Make sure you type the exact name, as appeared" +
									"in IIS Manager";
				
				Console.WriteLine(response); 
			}
        }
    }
}